
/************************************************************************/
/*                                                                      */
/*  COMPILADORS I                                                       */
/*                                                                      */
/*                                                                      */
/*  Autors: Francisco Jose Aguilar Celdran y Sergio Blanco Cuaresma     */
/*                                                                      */       
/************************************************************************/

#define MODUL_CUA
#include <stdlib.h>
#include <stdio.h>
#include "cua.h"
    
/* ------------------------------ */
/* CREAR_CUA: Crea una nova cua.  */
/* ------------------------------ */
         
Cua *crear_cua(void)
{
   Cua *nova;

   nova =(Cua *)malloc(sizeof(Cua));
   nova -> primer = NULL;
   nova -> ultim = NULL;
   nova -> pdi = NULL;   
   return nova;
}

/* ---------------------------------------------- */
/* CUA_BUIDA: respon si la cua esta o no buida.   */
/* ---------------------------------------------- */

unsigned int cua_buida(Cua *c)
{
   if(c -> primer == NULL) 
      return 1;
   else 
      return 0;
}

/* ------------------------------------------------------------- */
/* ENCUAR: afefeix com a ultim element de la cua el node rebut.  */
/* ------------------------------------------------------------- */

void encuar(Cua *c, void *valors)
{
   Node_Cua *nou_node;
   
   nou_node = (Node_Cua *)malloc(sizeof(Node_Cua));
   nou_node -> node = valors;
   nou_node -> anterior = NULL;
   if (cua_buida(c))
   {
      c -> primer = nou_node;
      c -> ultim = nou_node;
      c -> pdi = nou_node;
   }
   else
   {
      c -> ultim -> anterior = nou_node;
      c -> ultim = nou_node;
   } 
}

/* ------------------------------------------------ */
/* DESENCUAR: elimina el primer element de la cua.  */
/* ------------------------------------------------ */

void desencuar(Cua *c)
{
   Node_Cua *aux;
   
   if (!cua_buida(c))
   {  
      if (c -> primer -> anterior == NULL)
      {
         c -> primer = NULL; 
         c -> ultim = NULL;
         c -> pdi = NULL;
      }  
      else
      {
         aux = c -> primer;
         c -> primer = c -> primer -> anterior;
         free(aux);
      }
   }
}

/* --------------------------------------------- */
/* PRIMER: retorna el primer element de la cua.  */
/* --------------------------------------------- */

void *primer(Cua *c)
{
   if (c -> primer != NULL)
      return c -> primer -> node;
   else
      return NULL;
}

/* ----------------------------------------------------------------------- */
/* REINICIAR_PDI: ubica el Punt d'Interes en el primer element de la cua.  */
/* ----------------------------------------------------------------------- */

void reiniciar_PDI(Cua *c)
{
   c -> pdi = c -> primer;   
}

/* ---------------------------------------------------------------------------- */
/* OBTENIR_ELEMENT_ PDI: retorna el node apuntat pel Punt d'Interes de la cua.  */
/* ---------------------------------------------------------------------------- */

void *obtenir_element_PDI(Cua *c)
{
   if (c -> pdi != NULL)
      return c -> pdi -> node;
   else
      return NULL;
}

/* ------------------------------------------------------------------ */
/* seguent_PDI: ubica el Punt d'Interes a l'ement seguent de la cua.  */
/* ------------------------------------------------------------------ */

int seguent_PDI(Cua *c)
{
   if (c -> pdi != NULL)
   {
      c -> pdi = c -> pdi -> anterior; 
      return 1;
   }
   else
      return 0;   
}


